function connectMirror (context) {
  var sketch = context.api();

  var mirror;
  try {
    mirror = NSApp.delegate().mirrorController();
  } catch (e) {}
  if (!mirror) {
    sketch.message('Unexpected error happened (Error 101)');
    return;
  }

  var url;
  if ( mirror.whitelistClientAdvertisementID ) {
    var clientId = [[NSUUID alloc] init];
    var webUrl = mirror.webURL();
    mirror.whitelistClientAdvertisementID(clientId);
    url = [webUrl absoluteString] + '?uuid=' + clientId;
  } else {
    url = [[mirror authorizedWebURL] absoluteString];
  }

  if (!url) {
    sketch.message('Unexpected error happened (Error 105)');
    return;
  }

  url = NSString.stringWithFormat("%@", url);
  var query = 'url=' + [url stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLPathAllowedCharacterSet]];
  
  var components = [NSURLComponents new];
  [components setScheme:@"mockuuups"];
  [components setHost:@"sketch"];
  [components setQuery:query];
  [[NSWorkspace sharedWorkspace] openURL:[components URL]];

  sketch.message('Opening this document in Mockuuups Studio…');
}
